package com.gct.tools.etlcamelhuge.camelconfig;

import com.gct.tools.etlcamelhuge.quartz.SyncWellSourceTask;
import org.quartz.*;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import static org.quartz.CronScheduleBuilder.cronSchedule;

@Configuration
public class QuartzConfig {


    @Bean
    public JobDetail jobDetail() {
        return JobBuilder.newJob(SyncWellSourceTask.class)
                .withIdentity("ModbusReadTask" ,"Group1")
                .storeDurably()
                .build();
    }

    @Bean
    public Trigger trigger() {
        return TriggerBuilder.newTrigger()
                .forJob("ModbusReadTask", "Group1")
                .withSchedule(SimpleScheduleBuilder.simpleSchedule()
                        .withIntervalInHours(1)  // 间隔1小时
                        .repeatForever()).build();
    }
}
