package com.gct.tools.etlcamelhuge.quartz;

import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.scheduling.quartz.QuartzJobBean;

import javax.annotation.Resource;
import javax.sql.DataSource;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.atomic.AtomicInteger;

public class SyncWellSourceTask extends QuartzJobBean {

    @Resource(name = "oracle")
    DataSource oracle;

    @Resource(name = "centralbase")
    DataSource centralbase;

    private void orgUpdate(){
        JdbcTemplate oracleTemplate = new JdbcTemplate(oracle);
        final JdbcTemplate centralbaseTemplate = new JdbcTemplate(centralbase);
        String sql = String.format("select * from zy_dxgw.V_PC_ORGANIZATION_T where CANTON = '重油公司'");
        List<Map<String, Object>> results = oracleTemplate.queryForList(sql);

        Map<String, Map<String, Object>> parentObjMap = new HashMap<>();
        Map<String, Map<String, Object>> orgIdMap = new HashMap<>();
        AtomicInteger a = new AtomicInteger(1);
        results.forEach(rowMap -> {
            rowMap.put("org_id_map_int",a.getAndIncrement());
            orgIdMap.put(rowMap.get("ORG_ID").toString(), rowMap);
        });
        results.forEach(rowMap -> {
            parentObjMap.put(rowMap.get("ORG_ID").toString(), orgIdMap.get(rowMap.get("PARENT_ID")));
        });

        results.forEach(rowMap -> {
            Stack<String> orgPreStack = new Stack<>();
            Map<String, Object> parentObj = rowMap;

            while ((parentObj = parentObjMap.get(parentObj.get("ORG_ID").toString())) != null) {
                orgPreStack.push(parentObj.get("ORG_NAME").toString());
            }
            StringBuilder orgIdPre = new StringBuilder();
            while (!orgPreStack.isEmpty()) {
                orgIdPre.append(orgPreStack.pop()).append("@");
            }
            orgIdPre.append(rowMap.get("ORG_NAME"));
            String orgIdPreStr = orgIdPre.toString();
            rowMap.put("ORG_ID_PRE",orgIdPreStr);

         /*   String sqlInsertOrg = String.format("insert into centralbase.cb_pc_organization(" +
                            "org_id,org_name,org_code,org_level,parent_id,org_id_pre) " +
                            "values('%s','%s','%s','%s','%s','%s')", rowMap.get("org_id_map_int"), rowMap.get("ORG_NAME"), rowMap.get("ORG_CODE"),
                    orgIdPreStr.split("@").length
                    , Objects.nonNull(orgIdMap.get(rowMap.get("PARENT_ID").toString()))?orgIdMap.get(rowMap.get("PARENT_ID").toString()).get("org_id_map_int"):"0"
                    , orgIdPreStr);
//            System.out.println(sqlInsertOrg);
            centralbaseTemplate.execute(sqlInsertOrg);  */ //excute finish, unused
        });

        if(a.get()>1)return;
        //excute wellsource
        sql = String.format("select WELL_ID,well_common_name,org_id from " +
                "zy_dxgw.pc_dev_well_attr_info where well_purpose_name='采油井'");
        results = oracleTemplate.queryForList(sql);
        results.forEach(rowMap -> {
            String wellId = rowMap.get("WELL_ID").toString();
            String wellCommonName = rowMap.get("WELL_COMMON_NAME").toString();
            String wellLegalName = rowMap.get("WELL_COMMON_NAME").toString();
            String orgId = rowMap.get("ORG_ID").toString();
            String orgIdMapInt = orgIdMap.get(orgId).get("org_id_map_int").toString();
            String stationId = orgIdMap.get(orgId).get("ORG_ID_PRE").toString();


            String sqlQueryWellSource = String.format("select * from centralbase.cb_cd_well_source where well_id = '%s'",wellId);
            List<Map<String, Object>> maps = centralbaseTemplate.queryForList(sqlQueryWellSource);
            if(maps.isEmpty()){
                System.out.println("===========> 添加新井: "+wellCommonName);
                String  sqlInsertWellSource = String.format("insert into centralbase.cb_cd_well_source(well_id,well_common_name," +
                                "well_legal_name,org_id,station_id) values('%s','%s','%s','%s','%s')",
                        wellId, wellCommonName, wellLegalName, orgIdMapInt, stationId);
//            System.out.println(sqlInsertWellSource);
                centralbaseTemplate.execute(sqlInsertWellSource);

                String sqlInsertSysWellControl = String.format("insert into centralbase.sys_access_well_control(well_id," +
                        "well_common_name,org_id,access_date,access_status) values('%s','%s','%s','%s,'%s')",
                        wellId, wellCommonName, orgIdMapInt, LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")),"1");
                centralbaseTemplate.execute(sqlInsertSysWellControl);
            }
        });
    }

    @Override
    protected void executeInternal(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        orgUpdate();
    }
}

